// Zdrojovy soubor Buffer.cpp

#include "stdafx.h"

#include <stdio.h>
#include <iostream.h>

#include "Buffer.h"

int Buffer::s_PocetByte = 0;    // Pocatecni inicializace

Buffer::Buffer()
{
	m_Buffer = 0;
	m_Velikost = 0;
}

Buffer::Buffer(int _velikost) 
{
	m_Buffer = NULL;
	m_Velikost = 0;
	m_Buffer = new char[_velikost];
	if(m_Buffer) { // V pripade uspechu nastavime velikost a pricteme k nasi staticke promenne
		m_Velikost = _velikost;
		s_PocetByte += m_Velikost;
	}
}

Buffer::Buffer(Buffer& puvodni)
{
	m_Buffer = new char[puvodni.m_Velikost];
	// Pokud se buffer vytvori, pak nastavime velikost pole
	if(m_Buffer) {
		m_Velikost = puvodni.m_Velikost;
		s_PocetByte += m_Velikost;
	}

	// Prekopirujeme vsechny prvky
	for(int i = 0; i < puvodni.m_Velikost; i++)
	{
		m_Buffer[i] = puvodni.m_Buffer[i];
	}
} 

Buffer::~Buffer()
{
	if(m_Buffer) {
		delete[] m_Buffer; m_Buffer = NULL;
		s_PocetByte -= m_Velikost;
	}
}

// Starsi verze (bez male optimalizace)
/*
Buffer& Buffer::operator=(Buffer& Buf)
{
	if(m_Buffer)
	{
		delete(m_Buffer);
		s_PocetByte -= m_Velikost;
		m_Velikost = 0;
	}

	m_Buffer = new char[Buf.m_Velikost];
	
	if(m_Buffer)
	{
		m_Velikost = Buf.m_Velikost;
		s_PocetByte += m_Velikost;

		for(int i = 0; i < m_Velikost; i++)
		{
			m_Buffer[i] = Buf.m_Buffer[i];
		}
	}

	return *this;
}*/

Buffer& Buffer::operator=(Buffer& Buf)
{
	if(m_Velikost == Buf.m_Velikost)
	{
		cout << "- just copying\n";
		s_PocetByte -= m_Velikost;
	}
	else
	{
		cout << "- deleting memory\n";
		if(m_Buffer)
		{
			delete(m_Buffer);
			s_PocetByte -= m_Velikost;
			m_Velikost = 0;
		}

		m_Buffer = new char[Buf.m_Velikost];
	}
	
	if(m_Buffer)
	{
		s_PocetByte += m_Velikost;
		m_Velikost = Buf.m_Velikost;
		
		for(int i = 0; i < m_Velikost; i++)
		{
			m_Buffer[i] = Buf.m_Buffer[i];
		}
	}

	return *this;
}

char& Buffer::operator[](int indx)
{
	if(m_Buffer)
	{
		if(indx < m_Velikost)	// Osetrime preteceni mezi
		{
			return m_Buffer[indx];
		}
		else
		{
			cout << "m_Velikost je mensi nez index : " << m_Velikost << endl;
			return m_Buffer[m_Velikost - 1];
		}
	}
	else
	{
		// jinak vytvorime pole, kam se index vejde
		cout << "vytvarim nove pole" << endl;
		m_Buffer = new char[indx+1];	// Pole se indexuje od 0
		if(m_Buffer)
		{
			m_Velikost = indx + 1;
			s_PocetByte += m_Velikost;
			return m_Buffer[indx];
		}
		else
		{
			cout << "vracim zacatek pole, ale dojde k chybe pristupu do pameti" << endl;
			return *m_Buffer;
		}
	}
}

void Buffer::NastavNa(char hodnota)
{ 
	if(m_Buffer) { 
		for(int i = 0; i < m_Velikost; i++) 
		{ m_Buffer[i] = hodnota; }
	}
}

void Buffer::ZapisNa(int _pozice, char _hodnota)
{
	if(m_Buffer && (_pozice < m_Velikost)) // Jestlize jsme v mezich
	{ m_Buffer[_pozice] = _hodnota; }
}

void Buffer::Vypis()
{
	if(m_Buffer) { 
		for(int i = 0; i < m_Velikost; i++)
		{ cout << m_Buffer[i] << "|"; }
		cout << endl; // Radek mezi dvema vypisy
	}
}